test: drop the implicit prereq check mechanism from test_expect_*
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 this_test=${0##*/}
30 this_test=${this_test%.sh}
31 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
32
33 # if --tee was passed, write the output not only to the terminal, but
34 # additionally to the file test-results/$BASENAME.out, too.
35 case "$GIT_TEST_TEE_STARTED, $* " in
36 done,*)
37         # do not redirect again
38         ;;
39 *' --tee '*|*' --va'*)
40         mkdir -p test-results
41         BASE=test-results/$this_test
42         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
43          echo $? > $BASE.exit) | tee $BASE.out
44         test "$(cat $BASE.exit)" = 0
45         exit
46         ;;
47 esac
48
49 # Save STDOUT to fd 6 and STDERR to fd 7.
50 exec 6>&1 7>&2
51 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
52 BASH_XTRACEFD=7
53 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
54
55 # Keep the original TERM for say_color and test_emacs
56 ORIGINAL_TERM=$TERM
57
58 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
59 # Otherwise use whatever TERM is currently used so that
60 # users' actual TERM environments are being used in tests.
61 case ${TERM-} in
62         '' | dumb | unknown )
63                 SMART_TERM=vt100 ;;
64         *)
65                 SMART_TERM=$TERM ;;
66 esac
67
68 # For repeatability, reset the environment to known value.
69 LANG=C
70 LC_ALL=C
71 PAGER=cat
72 TZ=UTC
73 TERM=dumb
74 export LANG LC_ALL PAGER TERM TZ
75 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
76 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
77       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
78     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
79     exit 1
80 fi
81 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
82 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
83 TEST_GDB=${TEST_GDB:-gdb}
84 TEST_CC=${TEST_CC:-cc}
85 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
86
87 # Protect ourselves from common misconfiguration to export
88 # CDPATH into the environment
89 unset CDPATH
90
91 unset GREP_OPTIONS
92
93 # For emacsclient
94 unset ALTERNATE_EDITOR
95
96 # Each test should start with something like this, after copyright notices:
97 #
98 # test_description='Description of this test...
99 # This test checks if command xyzzy does the right thing...
100 # '
101 # . ./test-lib.sh || exit 1
102
103 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
104                 TERM=$ORIGINAL_TERM &&
105                 export TERM &&
106                 [ -t 1 ] &&
107                 tput bold >/dev/null 2>&1 &&
108                 tput setaf 1 >/dev/null 2>&1 &&
109                 tput sgr0 >/dev/null 2>&1
110         ) &&
111         color=t
112
113 while test "$#" -ne 0
114 do
115         case "$1" in
116         -d|--debug)
117                 debug=t; shift ;;
118         -i|--immediate)
119                 immediate=t; shift ;;
120         -h|--help)
121                 help=t; shift ;;
122         -v|--verbose)
123                 verbose=t; shift ;;
124         -q|--quiet)
125                 quiet=t; shift ;;
126         --with-dashes)
127                 with_dashes=t; shift ;;
128         --no-color)
129                 color=; shift ;;
130         --no-python)
131                 # noop now...
132                 shift ;;
133         --valgrind)
134                 valgrind=t; verbose=t; shift ;;
135         --tee)
136                 shift ;; # was handled already
137         --root=*)
138                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
139                 shift ;;
140         *)
141                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
142         esac
143 done
144
145 if test -n "$debug"; then
146     print_subtest () {
147         printf " %-4s" "[$((test_count - 1))]"
148     }
149 else
150     print_subtest () {
151         true
152     }
153 fi
154
155 if test -n "$color"; then
156         say_color () {
157                 (
158                 TERM=$ORIGINAL_TERM
159                 export TERM
160                 case "$1" in
161                         error) tput bold; tput setaf 1;; # bold red
162                         skip)  tput bold; tput setaf 2;; # bold green
163                         pass)  tput setaf 2;;            # green
164                         info)  tput setaf 3;;            # brown
165                         *) test -n "$quiet" && return;;
166                 esac
167                 shift
168                 printf " "
169                 printf "$@"
170                 tput sgr0
171                 print_subtest
172                 )
173         }
174 else
175         say_color() {
176                 test -z "$1" && test -n "$quiet" && return
177                 shift
178                 printf " "
179                 printf "$@"
180                 print_subtest
181         }
182 fi
183
184 error () {
185         say_color error "error: $*\n"
186         GIT_EXIT_OK=t
187         exit 1
188 }
189
190 say () {
191         say_color info "$*"
192 }
193
194 test "${test_description}" != "" ||
195 error "Test script did not set test_description."
196
197 if test "$help" = "t"
198 then
199         echo "Tests ${test_description}"
200         exit 0
201 fi
202
203 test_description_printed=
204 print_test_description ()
205 {
206         test -z "$test_description_printed" || return 0
207         echo
208         echo $this_test: "Testing ${test_description}"
209         test_description_printed=1
210 }
211 if [ -z "$NOTMUCH_TEST_QUIET" ]
212 then
213         print_test_description
214 fi
215
216 test_failure=0
217 test_count=0
218 test_fixed=0
219 test_broken=0
220 test_success=0
221
222 _exit_common () {
223         code=$?
224         trap - EXIT
225         set +ex
226         rm -rf "$TEST_TMPDIR"
227 }
228
229 trap_exit () {
230         _exit_common
231         if test -n "$GIT_EXIT_OK"
232         then
233                 exit $code
234         else
235                 exec >&6
236                 say_color error '%-6s' FATAL
237                 echo " $test_subtest_name"
238                 echo
239                 echo "Unexpected exit while executing $0. Exit code $code."
240                 exit 1
241         fi
242 }
243
244 trap_signal () {
245         _exit_common
246         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
247         exit $code
248 }
249
250 die () {
251         _exit_common
252         exec >&6
253         say_color error '%-6s' FATAL
254         echo " $*"
255         echo
256         echo "Unexpected exit while executing $0."
257         exit 1
258 }
259
260 GIT_EXIT_OK=
261 # Note: TEST_TMPDIR *NOT* exported!
262 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
263 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
264 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
265 trap 'trap_exit' EXIT
266 trap 'trap_signal' HUP INT TERM
267
268 # Generate a new message in the mail directory, with a unique message
269 # ID and subject. The message is not added to the index.
270 #
271 # After this function returns, the filename of the generated message
272 # is available as $gen_msg_filename and the message ID is available as
273 # $gen_msg_id .
274 #
275 # This function supports named parameters with the bash syntax for
276 # assigning a value to an associative array ([name]=value). The
277 # supported parameters are:
278 #
279 #  [dir]=directory/of/choice
280 #
281 #       Generate the message in directory 'directory/of/choice' within
282 #       the mail store. The directory will be created if necessary.
283 #
284 #  [filename]=name
285 #
286 #       Store the message in file 'name'. The default is to store it
287 #       in 'msg-<count>', where <count> is three-digit number of the
288 #       message.
289 #
290 #  [body]=text
291 #
292 #       Text to use as the body of the email message
293 #
294 #  '[from]="Some User <user@example.com>"'
295 #  '[to]="Some User <user@example.com>"'
296 #  '[subject]="Subject of email message"'
297 #  '[date]="RFC 822 Date"'
298 #
299 #       Values for email headers. If not provided, default values will
300 #       be generated instead.
301 #
302 #  '[cc]="Some User <user@example.com>"'
303 #  [reply-to]=some-address
304 #  [in-reply-to]=<message-id>
305 #  [references]=<message-id>
306 #  [content-type]=content-type-specification
307 #  '[header]=full header line, including keyword'
308 #
309 #       Additional values for email headers. If these are not provided
310 #       then the relevant headers will simply not appear in the
311 #       message.
312 #
313 #  '[id]=message-id'
314 #
315 #       Controls the message-id of the created message.
316 gen_msg_cnt=0
317 gen_msg_filename=""
318 gen_msg_id=""
319 generate_message ()
320 {
321     # This is our (bash-specific) magic for doing named parameters
322     local -A template="($@)"
323     local additional_headers
324
325     gen_msg_cnt=$((gen_msg_cnt + 1))
326     if [ -z "${template[filename]}" ]; then
327         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
328     else
329         gen_msg_name=${template[filename]}
330     fi
331
332     if [ -z "${template[id]}" ]; then
333         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
334     else
335         gen_msg_id="${template[id]}"
336     fi
337
338     if [ -z "${template[dir]}" ]; then
339         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
340     else
341         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
342         mkdir -p "$(dirname "$gen_msg_filename")"
343     fi
344
345     if [ -z "${template[body]}" ]; then
346         template[body]="This is just a test message (#${gen_msg_cnt})"
347     fi
348
349     if [ -z "${template[from]}" ]; then
350         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
351     fi
352
353     if [ -z "${template[to]}" ]; then
354         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
355     fi
356
357     if [ -z "${template[subject]}" ]; then
358         if [ -n "$test_subtest_name" ]; then
359             template[subject]="$test_subtest_name"
360         else
361             template[subject]="Test message #${gen_msg_cnt}"
362         fi
363     elif [ "${template[subject]}" = "@FORCE_EMPTY" ]; then
364         template[subject]=""
365     fi
366
367     if [ -z "${template[date]}" ]; then
368         # we use decreasing timestamps here for historical reasons;
369         # the existing test suite when we converted to unique timestamps just
370         # happened to have signicantly fewer failures with that choice.
371         local date_secs=$((978709437 - gen_msg_cnt))
372         # printf %(..)T is bash 4.2+ feature. use perl fallback if needed...
373         TZ=UTC printf -v template[date] "%(%a, %d %b %Y %T %z)T" $date_secs 2>/dev/null ||
374             template[date]=`perl -le 'use POSIX "strftime";
375                                 @time = gmtime '"$date_secs"';
376                                 print strftime "%a, %d %b %Y %T +0000", @time'`
377     fi
378
379     additional_headers=""
380     if [ ! -z "${template[header]}" ]; then
381         additional_headers="${template[header]}
382 ${additional_headers}"
383     fi
384
385     if [ ! -z "${template[reply-to]}" ]; then
386         additional_headers="Reply-To: ${template[reply-to]}
387 ${additional_headers}"
388     fi
389
390     if [ ! -z "${template[in-reply-to]}" ]; then
391         additional_headers="In-Reply-To: ${template[in-reply-to]}
392 ${additional_headers}"
393     fi
394
395     if [ ! -z "${template[cc]}" ]; then
396         additional_headers="Cc: ${template[cc]}
397 ${additional_headers}"
398     fi
399
400     if [ ! -z "${template[bcc]}" ]; then
401         additional_headers="Bcc: ${template[bcc]}
402 ${additional_headers}"
403     fi
404
405     if [ ! -z "${template[references]}" ]; then
406         additional_headers="References: ${template[references]}
407 ${additional_headers}"
408     fi
409
410     if [ ! -z "${template[content-type]}" ]; then
411         additional_headers="Content-Type: ${template[content-type]}
412 ${additional_headers}"
413     fi
414
415     if [ ! -z "${template[content-transfer-encoding]}" ]; then
416         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
417 ${additional_headers}"
418     fi
419
420     # Note that in the way we're setting it above and using it below,
421     # `additional_headers' will also serve as the header / body separator
422     # (empty line in between).
423
424     cat <<EOF >"$gen_msg_filename"
425 From: ${template[from]}
426 To: ${template[to]}
427 Message-Id: <${gen_msg_id}>
428 Subject: ${template[subject]}
429 Date: ${template[date]}
430 ${additional_headers}
431 ${template[body]}
432 EOF
433 }
434
435 # Generate a new message and add it to the database.
436 #
437 # All of the arguments and return values supported by generate_message
438 # are also supported here, so see that function for details.
439 add_message ()
440 {
441     generate_message "$@" &&
442     notmuch new > /dev/null
443 }
444
445 # Deliver a message with emacs and add it to the database
446 #
447 # Uses emacs to generate and deliver a message to the mail store.
448 # Accepts arbitrary extra emacs/elisp functions to modify the message
449 # before sending, which is useful to doing things like attaching files
450 # to the message and encrypting/signing.
451 emacs_deliver_message ()
452 {
453     local subject="$1"
454     local body="$2"
455     shift 2
456     # before we can send a message, we have to prepare the FCC maildir
457     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
458     # eval'ing smtp-dummy --background will set smtp_dummy_pid
459     smtp_dummy_pid=
460     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
461     test -n "$smtp_dummy_pid" || return 1
462
463     test_emacs \
464         "(let ((message-send-mail-function 'message-smtpmail-send-it)
465                (mail-host-address \"example.com\")
466                (smtpmail-smtp-server \"localhost\")
467                (smtpmail-smtp-service \"25025\"))
468            (notmuch-mua-mail)
469            (message-goto-to)
470            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
471            (message-goto-subject)
472            (insert \"${subject}\")
473            (message-goto-body)
474            (insert \"${body}\")
475            $@
476            (notmuch-mua-send-and-exit))"
477
478     # In case message was sent properly, client waits for confirmation
479     # before exiting and resuming control here; therefore making sure
480     # that server exits by sending (KILL) signal to it is safe.
481     kill -9 $smtp_dummy_pid
482     notmuch new >/dev/null
483 }
484
485 # Pretend to deliver a message with emacs. Really save it to a file
486 # and add it to the database
487 #
488 # Uses emacs to generate and deliver a message to the mail store.
489 # Accepts arbitrary extra emacs/elisp functions to modify the message
490 # before sending, which is useful to doing things like attaching files
491 # to the message and encrypting/signing.
492 emacs_fcc_message ()
493 {
494     local subject="$1"
495     local body="$2"
496     shift 2
497     # before we can send a message, we have to prepare the FCC maildir
498     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
499
500     test_emacs \
501         "(let ((message-send-mail-function (lambda () t))
502                (mail-host-address \"example.com\"))
503            (notmuch-mua-mail)
504            (message-goto-to)
505            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
506            (message-goto-subject)
507            (insert \"${subject}\")
508            (message-goto-body)
509            (insert \"${body}\")
510            $@
511            (notmuch-mua-send-and-exit))" || return 1
512     notmuch new >/dev/null
513 }
514
515 # Add an existing, fixed corpus of email to the database.
516 #
517 # $1 is the corpus dir under corpora to add, using "default" if unset.
518 #
519 # The default corpus is based on about 50 messages from early in the
520 # history of the notmuch mailing list, which allows for reliably
521 # testing commands that need to operate on a not-totally-trivial
522 # number of messages.
523 add_email_corpus ()
524 {
525     corpus=${1:-default}
526
527     rm -rf ${MAIL_DIR}
528     if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
529         cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
530     else
531         cp -a $TEST_DIRECTORY/corpora/$corpus ${MAIL_DIR}
532         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
533         mkdir -p $TEST_DIRECTORY/corpora.mail
534         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
535     fi
536 }
537
538 test_begin_subtest ()
539 {
540     if [ -n "$inside_subtest" ]; then
541         exec 1>&6 2>&7          # Restore stdout and stderr
542         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
543     fi
544     test_subtest_name="$1"
545     test_reset_state_
546     # Redirect test output to the previously prepared file descriptors
547     # 3 and 4 (see below)
548     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
549     exec >&3 2>&4
550     inside_subtest=t
551 }
552
553 # Pass test if two arguments match
554 #
555 # Note: Unlike all other test_expect_* functions, this function does
556 # not accept a test name. Instead, the caller should call
557 # test_begin_subtest before calling this function in order to set the
558 # name.
559 test_expect_equal ()
560 {
561         exec 1>&6 2>&7          # Restore stdout and stderr
562         if [ -z "$inside_subtest" ]; then
563                 error "bug in the test script: test_expect_equal without test_begin_subtest"
564         fi
565         inside_subtest=
566         test "$#" = 2 ||
567         error "bug in the test script: not 2 parameters to test_expect_equal"
568
569         output="$1"
570         expected="$2"
571         if ! test_skip "$test_subtest_name"
572         then
573                 if [ "$output" = "$expected" ]; then
574                         test_ok_
575                 else
576                         testname=$this_test.$test_count
577                         echo "$expected" > $testname.expected
578                         echo "$output" > $testname.output
579                         test_failure_ "$(diff -u $testname.expected $testname.output)"
580                 fi
581     fi
582 }
583
584 # Like test_expect_equal, but takes two filenames.
585 test_expect_equal_file ()
586 {
587         exec 1>&6 2>&7          # Restore stdout and stderr
588         if [ -z "$inside_subtest" ]; then
589                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
590         fi
591         inside_subtest=
592         test "$#" = 2 ||
593         error "bug in the test script: not 2 parameters to test_expect_equal_file"
594
595         file1="$1"
596         file2="$2"
597         if ! test_skip "$test_subtest_name"
598         then
599                 if diff -q "$file1" "$file2" >/dev/null ; then
600                         test_ok_
601                 else
602                         testname=$this_test.$test_count
603                         basename1=`basename "$file1"`
604                         basename2=`basename "$file2"`
605                         cp "$file1" "$testname.$basename1"
606                         cp "$file2" "$testname.$basename2"
607                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
608                 fi
609     fi
610 }
611
612 # Like test_expect_equal, but arguments are JSON expressions to be
613 # canonicalized before diff'ing.  If an argument cannot be parsed, it
614 # is used unchanged so that there's something to diff against.
615 test_expect_equal_json () {
616     # The test suite forces LC_ALL=C, but this causes Python 3 to
617     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
618     # override Python's stdio encoding defaults.
619     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
620         || echo "$1")
621     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
622         || echo "$2")
623     shift 2
624     test_expect_equal "$output" "$expected" "$@"
625 }
626
627 # Sort the top-level list of JSON data from stdin.
628 test_sort_json () {
629     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
630         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
631 }
632
633 test_emacs_expect_t () {
634         test "$#" = 1 ||
635         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
636         if [ -z "$inside_subtest" ]; then
637                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
638         fi
639
640         # Run the test.
641         if ! test_skip "$test_subtest_name"
642         then
643                 test_emacs "(notmuch-test-run $1)" >/dev/null
644
645                 # Restore state after the test.
646                 exec 1>&6 2>&7          # Restore stdout and stderr
647                 inside_subtest=
648
649                 # Report success/failure.
650                 result=$(cat OUTPUT)
651                 if [ "$result" = t ]
652                 then
653                         test_ok_
654                 else
655                         test_failure_ "${result}"
656                 fi
657         else
658                 # Restore state after the (non) test.
659                 exec 1>&6 2>&7          # Restore stdout and stderr
660                 inside_subtest=
661         fi
662 }
663
664 NOTMUCH_NEW ()
665 {
666     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
667 }
668
669 NOTMUCH_DUMP_TAGS ()
670 {
671     # this relies on the default format being batch-tag, otherwise some tests will break
672     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
673 }
674
675 notmuch_search_sanitize ()
676 {
677     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
678 }
679
680 notmuch_search_files_sanitize ()
681 {
682     notmuch_dir_sanitize
683 }
684
685 notmuch_dir_sanitize ()
686 {
687     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
688 }
689
690 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
691 notmuch_show_sanitize ()
692 {
693     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
694 }
695 notmuch_show_sanitize_all ()
696 {
697     sed \
698         -e 's| filename:.*| filename:XXXXX|' \
699         -e 's| id:[^ ]* | id:XXXXX |' | \
700         notmuch_date_sanitize
701 }
702
703 notmuch_json_show_sanitize ()
704 {
705     sed \
706         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
707         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
708         -e 's|"filename": "signature.asc",||g' \
709         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
710         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
711         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
712 }
713
714 notmuch_emacs_error_sanitize ()
715 {
716     local command=$1
717     shift
718     for file in "$@"; do
719         echo "=== $file ==="
720         cat "$file"
721     done | sed  \
722         -e 's/^\[.*\]$/[XXX]/' \
723         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
724 }
725
726 notmuch_date_sanitize ()
727 {
728     sed \
729         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
730 }
731
732 notmuch_uuid_sanitize ()
733 {
734     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
735 }
736
737 notmuch_built_with_sanitize ()
738 {
739     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
740 }
741
742 notmuch_config_sanitize ()
743 {
744     notmuch_dir_sanitize | notmuch_built_with_sanitize
745 }
746
747 # End of notmuch helper functions
748
749 # Use test_set_prereq to tell that a particular prerequisite is available.
750 #
751 # The prerequisite can later be checked for by using test_have_prereq.
752 #
753 # The single parameter is the prerequisite tag (a simple word, in all
754 # capital letters by convention).
755
756 test_set_prereq () {
757         satisfied="$satisfied$1 "
758 }
759 satisfied=" "
760
761 test_have_prereq () {
762         case $satisfied in
763         *" $1 "*)
764                 : yes, have it ;;
765         *)
766                 ! : nope ;;
767         esac
768 }
769
770 declare -A test_missing_external_prereq_
771 declare -A test_subtest_missing_external_prereq_
772
773 # declare prerequisite for the given external binary
774 test_declare_external_prereq () {
775         binary="$1"
776         test "$#" = 2 && name=$2 || name="$binary(1)"
777
778         if ! hash $binary 2>/dev/null; then
779                 test_missing_external_prereq_["${binary}"]=t
780                 eval "
781 $binary () {
782         test_subtest_missing_external_prereq_[\"${name}\"]=t
783         false
784 }"
785         fi
786 }
787
788 # Explicitly require external prerequisite.  Useful when binary is
789 # called indirectly (e.g. from emacs).
790 # Returns success if dependency is available, failure otherwise.
791 test_require_external_prereq () {
792         binary="$1"
793         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
794                 # dependency is missing, call the replacement function to note it
795                 eval "$binary"
796         else
797                 true
798         fi
799 }
800
801 # You are not expected to call test_ok_ and test_failure_ directly, use
802 # the text_expect_* functions instead.
803
804 test_ok_ () {
805         if test "$test_subtest_known_broken_" = "t"; then
806                 test_known_broken_ok_
807                 return
808         fi
809         test_success=$(($test_success + 1))
810         if test -n "$NOTMUCH_TEST_QUIET"; then
811                 return 0
812         fi
813         say_color pass "%-6s" "PASS"
814         echo " $test_subtest_name"
815 }
816
817 test_failure_ () {
818         print_test_description
819         if test "$test_subtest_known_broken_" = "t"; then
820                 test_known_broken_failure_ "$@"
821                 return
822         fi
823         test_failure=$(($test_failure + 1))
824         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
825         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
826         return 1
827 }
828
829 test_failure_message_ () {
830         say_color error "%-6s" "$1"
831         echo " $2"
832         shift 2
833         if [ "$#" != "0" ]; then
834                 echo "$@" | sed -e 's/^/        /'
835         fi
836         if test "$verbose" != "t"; then cat test.output; fi
837 }
838
839 test_known_broken_ok_ () {
840         test_reset_state_
841         test_fixed=$(($test_fixed+1))
842         say_color pass "%-6s" "FIXED"
843         echo " $test_subtest_name"
844 }
845
846 test_known_broken_failure_ () {
847         test_reset_state_
848         test_broken=$(($test_broken+1))
849         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
850                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
851         else
852                 test_failure_message_ "BROKEN" "$test_subtest_name"
853         fi
854         return 1
855 }
856
857 test_debug () {
858         test "$debug" = "" || eval "$1"
859 }
860
861 test_run_ () {
862         test_cleanup=:
863         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
864         eval >&3 2>&4 "$1"
865         eval_ret=$?
866         eval >&3 2>&4 "$test_cleanup"
867         return 0
868 }
869
870 test_skip () {
871         test_count=$(($test_count+1))
872         to_skip=
873         for skp in $NOTMUCH_SKIP_TESTS
874         do
875                 case $this_test.$test_count in
876                 $skp)
877                         to_skip=t
878                         break
879                 esac
880                 case $this_test_bare.$test_count in
881                 $skp)
882                         to_skip=t
883                         break
884                 esac
885         done
886         case "$to_skip" in
887         t)
888                 test_report_skip_ "$@"
889                 ;;
890         *)
891                 test_check_missing_external_prereqs_ "$@"
892                 ;;
893         esac
894 }
895
896 test_check_missing_external_prereqs_ () {
897         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
898                 say_color skip >&1 "missing prerequisites: "
899                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
900                 test_report_skip_ "$@"
901         else
902                 false
903         fi
904 }
905
906 test_report_skip_ () {
907         test_reset_state_
908         say_color skip >&3 "skipping test:"
909         echo " $@" >&3
910         say_color skip "%-6s" "SKIP"
911         echo " $1"
912 }
913
914 test_subtest_known_broken () {
915         test_subtest_known_broken_=t
916 }
917
918 test_expect_success () {
919         test "$#" = 2 ||
920         error "bug in the test script: not 2 parameters to test_expect_success"
921         test_subtest_name="$1"
922         test_reset_state_
923         if ! test_skip "$@"
924         then
925                 test_run_ "$2"
926                 run_ret="$?"
927                 # test_run_ may update missing external prerequisites
928                 test_check_missing_external_prereqs_ "$@" ||
929                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
930                 then
931                         test_ok_
932                 else
933                         test_failure_ "$2"
934                 fi
935         fi
936 }
937
938 test_expect_code () {
939         test "$#" = 3 ||
940         error "bug in the test script: not 3 parameters to test_expect_code"
941         test_subtest_name="$2"
942         test_reset_state_
943         if ! test_skip "$@"
944         then
945                 test_run_ "$3"
946                 run_ret="$?"
947                 # test_run_ may update missing external prerequisites,
948                 test_check_missing_external_prereqs_ "$@" ||
949                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
950                 then
951                         test_ok_
952                 else
953                         test_failure_ "exit code $eval_ret, expected $1" "$3"
954                 fi
955         fi
956 }
957
958 # This is not among top-level (test_expect_success)
959 # but is a prefix that can be used in the test script, like:
960 #
961 #       test_expect_success 'complain and die' '
962 #           do something &&
963 #           do something else &&
964 #           test_must_fail git checkout ../outerspace
965 #       '
966 #
967 # Writing this as "! git checkout ../outerspace" is wrong, because
968 # the failure could be due to a segv.  We want a controlled failure.
969
970 test_must_fail () {
971         "$@"
972         test $? -gt 0 -a $? -le 129 -o $? -gt 192
973 }
974
975 # test_cmp is a helper function to compare actual and expected output.
976 # You can use it like:
977 #
978 #       test_expect_success 'foo works' '
979 #               echo expected >expected &&
980 #               foo >actual &&
981 #               test_cmp expected actual
982 #       '
983 #
984 # This could be written as either "cmp" or "diff -u", but:
985 # - cmp's output is not nearly as easy to read as diff -u
986 # - not all diff versions understand "-u"
987
988 test_cmp() {
989         $GIT_TEST_CMP "$@"
990 }
991
992 # This function can be used to schedule some commands to be run
993 # unconditionally at the end of the test to restore sanity:
994 #
995 #       test_expect_success 'test core.capslock' '
996 #               git config core.capslock true &&
997 #               test_when_finished "git config --unset core.capslock" &&
998 #               hello world
999 #       '
1000 #
1001 # That would be roughly equivalent to
1002 #
1003 #       test_expect_success 'test core.capslock' '
1004 #               git config core.capslock true &&
1005 #               hello world
1006 #               git config --unset core.capslock
1007 #       '
1008 #
1009 # except that the greeting and config --unset must both succeed for
1010 # the test to pass.
1011
1012 test_when_finished () {
1013         test_cleanup="{ $*
1014                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1015 }
1016
1017 test_done () {
1018         GIT_EXIT_OK=t
1019         test_results_dir="$TEST_DIRECTORY/test-results"
1020         mkdir -p "$test_results_dir"
1021         test_results_path="$test_results_dir/$this_test"
1022
1023         echo "total $test_count" >> $test_results_path
1024         echo "success $test_success" >> $test_results_path
1025         echo "fixed $test_fixed" >> $test_results_path
1026         echo "broken $test_broken" >> $test_results_path
1027         echo "failed $test_failure" >> $test_results_path
1028         echo "" >> $test_results_path
1029
1030         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1031
1032         if [ "$test_failure" = "0" ]; then
1033             if [ "$test_broken" = "0" ]; then
1034                 rm -rf "$remove_tmp"
1035             fi
1036             exit 0
1037         else
1038             exit 1
1039         fi
1040 }
1041
1042 emacs_generate_script () {
1043         # Construct a little test script here for the benefit of the user,
1044         # (who can easily run "run_emacs" to get the same emacs environment
1045         # for investigating any failures).
1046         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1047 #!/bin/sh
1048 export PATH=$PATH
1049 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1050
1051 # Here's what we are using here:
1052 #
1053 # --quick              Use minimal customization. This implies --no-init-file,
1054 #                      --no-site-file and (emacs 24) --no-site-lisp
1055 #
1056 # --directory           Ensure that the local elisp sources are found
1057 #
1058 # --load                Force loading of notmuch.el and test-lib.el
1059
1060 exec ${TEST_EMACS} --quick \
1061         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1062         --directory "$TEST_DIRECTORY" --load test-lib.el \
1063         "\$@"
1064 EOF
1065         chmod a+x "$TMP_DIRECTORY/run_emacs"
1066 }
1067
1068 test_emacs () {
1069         # test dependencies beforehand to avoid the waiting loop below
1070         missing_dependencies=
1071         test_require_external_prereq dtach || missing_dependencies=1
1072         test_require_external_prereq emacs || missing_dependencies=1
1073         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1074         test -z "$missing_dependencies" || return
1075
1076         if [ -z "$EMACS_SERVER" ]; then
1077                 emacs_tests="${this_test_bare}.el"
1078                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1079                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1080                 else
1081                         load_emacs_tests=
1082                 fi
1083                 server_name="notmuch-test-suite-$$"
1084                 # start a detached session with an emacs server
1085                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1086                 # or unknown) is given to dtach which assumes a minimally
1087                 # VT100-compatible terminal -- and emacs inherits that
1088                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1089                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1090                                 --no-window-system \
1091                                 $load_emacs_tests \
1092                                 --eval '(setq server-name \"$server_name\")' \
1093                                 --eval '(server-start)' \
1094                                 --eval '(orphan-watchdog $$)'" || return
1095                 EMACS_SERVER="$server_name"
1096                 # wait until the emacs server is up
1097                 until test_emacs '()' >/dev/null 2>/dev/null; do
1098                         sleep 1
1099                 done
1100         fi
1101
1102         # Clear test-output output file.  Most Emacs tests end with a
1103         # call to (test-output).  If the test code fails with an
1104         # exception before this call, the output file won't get
1105         # updated.  Since we don't want to compare against an output
1106         # file from another test, so start out with an empty file.
1107         rm -f OUTPUT
1108         touch OUTPUT
1109
1110         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1111 }
1112
1113 test_python() {
1114     # Note: if there is need to print debug information from python program,
1115     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1116     PYTHONPATH="$TEST_DIRECTORY/../bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1117         $NOTMUCH_PYTHON -B - > OUTPUT
1118 }
1119
1120 test_ruby() {
1121     MAIL_DIR=$MAIL_DIR ruby -I $TEST_DIRECTORY/../bindings/ruby> OUTPUT
1122 }
1123
1124 test_C () {
1125     exec_file="test${test_count}"
1126     test_file="${exec_file}.c"
1127     cat > ${test_file}
1128     ${TEST_CC} ${TEST_CFLAGS} -I${TEST_DIRECTORY} -I${TEST_DIRECTORY}/../lib -o ${exec_file} ${test_file} -L${TEST_DIRECTORY}/../lib/ -lnotmuch -ltalloc
1129     echo "== stdout ==" > OUTPUT.stdout
1130     echo "== stderr ==" > OUTPUT.stderr
1131     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1132     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1133 }
1134
1135
1136 # Creates a script that counts how much time it is executed and calls
1137 # notmuch.  $notmuch_counter_command is set to the path to the
1138 # generated script.  Use notmuch_counter_value() function to get the
1139 # current counter value.
1140 notmuch_counter_reset () {
1141         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1142         if [ ! -x "$notmuch_counter_command" ]; then
1143                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1144                 cat >"$notmuch_counter_command" <<EOF || return
1145 #!/bin/sh
1146
1147 read count < "$notmuch_counter_state_path"
1148 echo \$((count + 1)) > "$notmuch_counter_state_path"
1149
1150 exec notmuch "\$@"
1151 EOF
1152                 chmod +x "$notmuch_counter_command" || return
1153         fi
1154
1155         echo 0 > "$notmuch_counter_state_path"
1156 }
1157
1158 # Returns the current notmuch counter value.
1159 notmuch_counter_value () {
1160         if [ -r "$notmuch_counter_state_path" ]; then
1161                 read count < "$notmuch_counter_state_path"
1162         else
1163                 count=0
1164         fi
1165         echo $count
1166 }
1167
1168 test_reset_state_ () {
1169         test -z "$test_init_done_" && test_init_
1170
1171         test_subtest_known_broken_=
1172         test_subtest_missing_external_prereq_=()
1173 }
1174
1175 # called once before the first subtest
1176 test_init_ () {
1177         test_init_done_=t
1178
1179         # skip all tests if there were external prerequisites missing during init
1180         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1181 }
1182
1183
1184 . ./test-lib-common.sh || exit 1
1185
1186 emacs_generate_script
1187
1188
1189 # Use -P to resolve symlinks in our working directory so that the cwd
1190 # in subprocesses like git equals our $PWD (for pathname comparisons).
1191 cd -P "$test" || error "Cannot set up test environment"
1192
1193 if test "$verbose" = "t"
1194 then
1195         exec 4>&2 3>&1
1196 else
1197         exec 4>test.output 3>&4
1198 fi
1199
1200 for skp in $NOTMUCH_SKIP_TESTS
1201 do
1202         to_skip=
1203         for skp in $NOTMUCH_SKIP_TESTS
1204         do
1205                 case "$this_test" in
1206                 $skp)
1207                         to_skip=t
1208                         break
1209                 esac
1210                 case "$this_test_bare" in
1211                 $skp)
1212                         to_skip=t
1213                         break
1214                 esac
1215         done
1216         case "$to_skip" in
1217         t)
1218                 say_color skip >&3 "skipping test $this_test altogether"
1219                 say_color skip "skip all tests in $this_test"
1220                 test_done
1221         esac
1222 done
1223
1224 # Provide an implementation of the 'yes' utility
1225 yes () {
1226         if test $# = 0
1227         then
1228                 y=y
1229         else
1230                 y="$*"
1231         fi
1232
1233         while echo "$y"
1234         do
1235                 :
1236         done
1237 }
1238
1239 # Fix some commands on Windows
1240 case $(uname -s) in
1241 *MINGW*)
1242         # Windows has its own (incompatible) sort and find
1243         sort () {
1244                 /usr/bin/sort "$@"
1245         }
1246         find () {
1247                 /usr/bin/find "$@"
1248         }
1249         sum () {
1250                 md5sum "$@"
1251         }
1252         # git sees Windows-style pwd
1253         pwd () {
1254                 builtin pwd -W
1255         }
1256         # no POSIX permissions
1257         # backslashes in pathspec are converted to '/'
1258         # exec does not inherit the PID
1259         ;;
1260 *)
1261         test_set_prereq POSIXPERM
1262         test_set_prereq BSLASHPSPEC
1263         test_set_prereq EXECKEEPSPID
1264         ;;
1265 esac
1266
1267 test -z "$NO_PERL" && test_set_prereq PERL
1268 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1269
1270 # test whether the filesystem supports symbolic links
1271 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1272 rm -f y
1273
1274 # convert variable from configure to more convenient form
1275 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1276     glass)
1277         db_ending=glass
1278     ;;
1279     chert)
1280         db_ending=DB
1281     ;;
1282     *)
1283         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1284 esac
1285 # declare prerequisites for external binaries used in tests
1286 test_declare_external_prereq dtach
1287 test_declare_external_prereq emacs
1288 test_declare_external_prereq ${TEST_EMACSCLIENT}
1289 test_declare_external_prereq ${TEST_GDB}
1290 test_declare_external_prereq gpg
1291 test_declare_external_prereq openssl
1292 test_declare_external_prereq gpgsm
1293 test_declare_external_prereq ${NOTMUCH_PYTHON}